// CurrentAgent.java

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;

import swarm.collections.ListImpl;

/**
 * This is a ghost agent which simply transfers the 'act' message to
 * the first agent in the list agentList and rotate it
 * this trick is necessary to send the act message agentNumber times; so
 * the observer can dispaly the price of each acting step.
 *
 * @author Marco Agagliate
 *
 */
public class CurrentAgent extends SwarmObjectImpl
        {
        /** This is the agent list. */
        ListImpl agentList;

        /** Constructor for a new CurrentAgent. */
        public CurrentAgent(Zone aZone)
                {
                super(aZone);
                }

        /** The method sets agentList. */
        public void setAgentList(ListImpl l) 
                {
                agentList = l;
                }

        /** The method calls the act1 method from an agent, which is in a list. */
        public void act1()
                {
                BasicSumAgent actingAgent;  
                actingAgent = (BasicSumAgent)agentList.removeFirst();
                agentList.addLast( actingAgent );
                actingAgent.act1();
                System.out.println("the acting agent is: "+actingAgent);
                }
        }
