// CurrentIstant.java

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;

import swarm.collections.ListImpl;

/**
 * This is a class for calling a different number of agents
 * for every istant of simulating day.
 * The CurrentAgent is called a numberOfOperatinAgents times.
 * 
 *
 * @author Marco Agagliate
 *
 */
public class CurrentIstant extends SwarmObjectImpl
        {
        /** The Current Agent of the simulation. */
        CurrentAgent theCurrentAgent;
        /** The number of operating agents per istant. */
        public int numberOfOperatingAgents;
        /**  The maximum number of operating agents. */
        public int maxNumberOfOperatingAgents;
        /**  The percentage quota of agents which act in the market.*/
        public int percentageOfOperatingAgents;
        /**  The type of percetage of agents. If it is true percentage
         *   is a maximum value; if it is false percentage is a
         *   fixed value.
         */
        public boolean typeOfPercentage;

        /** Constructor for a new CurrentIstant. */
        public CurrentIstant(Zone aZone)
                {
                super(aZone);
                }
        /** The method sets theCurrentAgent. */
        public void setCurrentAgent(CurrentAgent c) 
                {
                theCurrentAgent = c;
                }

        /** This method sets the maximum value of operating agents. */
        public void setMaxNumberOfOperatingAgents(int n) 
                {
                maxNumberOfOperatingAgents = n;
                }

        /** This method sets the percentage of operating agents. */
        public void setPercentageOfOperatingAgents(int p)
                {
                percentageOfOperatingAgents = p;
                }

        /** This method sets the type of percentage. */
        public void setTypeOfPercentage(boolean t) 
                {
                typeOfPercentage = t;
                }


        /** The method calls the CurrentAgent numberOfOperatingAgents times.
         *  The CurrentAgent calls act1 method from an agent, which is in a list.
         */
        public void callAgents()
                {
                int j;

                numberOfOperatingAgents = maxNumberOfOperatingAgents;
                if (typeOfPercentage == true)
                        {
                        numberOfOperatingAgents =
                                Globals.env.uniformIntRand.getIntegerWithMin$withMax
                                        (0 , maxNumberOfOperatingAgents);
                        if (percentageOfOperatingAgents == 0) numberOfOperatingAgents = 1;
                        }

                for (j=0;j<numberOfOperatingAgents;j++)
                        theCurrentAgent.act1();
                System.out.println("only "+numberOfOperatingAgents+" agent is operating");
                }
        }
