// RandomAgent.java

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;

/**
 * This is the RandomAgent. RandomAgent acts at random.
 * 
 * 
 *
 * @author Marco Agagliate 
 *  
 */
public class RandomAgent extends BasicSumAgent
        {
	/** This variable is for send order to the book. */
	public double[] order = new double[3];

        /** This is the agent's rule master. */
        public RandomRuleMaster ruleMaster;

        /** Constructor for a new RandomAgent. */
        public RandomAgent(Zone aZone,int maxOrderQuantity)
                {
                super(aZone, maxOrderQuantity);
                }

        /** This method sets the rule master. */
        public void setRuleMaster(RandomRuleMaster r)
                {
                ruleMaster=r;
                }

        /** This method is called in the first phase of the day. */
        public void act0()
                {
                double lastPrice;
                int i;

                buySellSwitch=0.5;
                lastPrice=theBook.getPrice(); 
                price = ruleMaster.getPriceBeforeOpening (lastPrice, buySellSwitch);
                if (maxOrderQuantity==1) 
                        iMax=1;
                else
                        iMax=Globals.env.uniformIntRand.getIntegerWithMin$withMax
                                                                (1, maxOrderQuantity);
		order[0]=price;
		order[1]=number;
		order[2]=iMax;
                theBook.setOrderBeforeOpeningFromAgent (order);
                System.out.println("I'm the random agent "+order[1]+" in act0 and I sent an order for "+order[2]+" shares at price"+order[0]);
                }

        /** This method is called in the first phase of the day.
         *  The agent acts in the market.
         */
        public void act1()
                {
                double lastPrice;
                int i;

                buySellSwitch=0.5;
                lastPrice=theBook.getPrice();
                price = ruleMaster.getPrice (lastPrice, buySellSwitch);
                if (maxOrderQuantity==1) 
                        iMax=1;
                else
                        iMax=Globals.env.uniformIntRand.getIntegerWithMin$withMax
                                                                (1, maxOrderQuantity);
		order[0]=price;
		order[1]=number;
		order[2]=iMax;
                theBook.setOrderFromAgent (order);
                System.out.println("I'm the random agent "+order[1]+" in act1 and I sent an order for "+order[2]+" shares at price"+order[0]);
                }
        }



