// RandomRuleMaster.java

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;

/**
 * This is the RandomRuleMaster. A rule master contains the rule
 * for the agent's acts.
 * 
 *
 * @author Marco Agagliate 
 *  
 */
public class RandomRuleMaster extends BasicSumRuleMaster
        {
        /** Constructor for a new RandomRuleMaster. */
        public RandomRuleMaster(Zone aZone)
                {
                super(aZone);
                }

        /**  This method is called before the market is open. */
        public double getPriceBeforeOpening(double lp, double p)
                {
                if (agentProbToActBeforeOpening < Globals.env.uniformDblRand
                                                        .getDoubleWithMin$withMax(0.0, 1.0))
                        return 0.0;
                else 
                        return this.getPrice(lp, p);
                }

        /**  This method is called  when the agent acts in the market. */
        public double getPrice(double lp, double p)
                {
                double price,  choice;

                price = lp * Globals.env.uniformDblRand.getDoubleWithMin$withMax
                    (minCorrectingCoeff + asymmetricRange, maxCorrectingCoeff + asymmetricRange);
                choice=1;
                if (Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0, 1.0) > p)
                        choice=-1;
                if (lp<floorP)
                        {
                        if (agentProbToActBelowFloorP > Globals.env.uniformDblRand
                                                           .getDoubleWithMin$withMax(0.0, 1.0))
                                {
                                price=lp;
                                choice=1;
                                }
                        }
                return choice*price;
                }
        }

