// StartJavaSum.java

import swarm.Globals;
import swarm.defobj.Zone;

/**
 * The StartJavaSum class contains main().
 * We follow here the typical Swarm structure with main() (in Start...
 * as a convention) generating the Observer and the Observer
 * generating the Model.
 *
 * @author Marco Agagliate
 */
public class StartJavaSum
        {
        /**
	 * The main() function is the top-level place where everything starts.
	 */
        public static void main (String[] args)
                {
                /** The observer in our application. */
                ObserverSwarm observerSwarm;

                // Swarm initialization: all Swarm apps must call this first.
                Globals.env.initSwarm ("JavaSum", "0.6", 
                               "pietro.terna@unito.it", args);

                // Create a top-level Swarm object, observerSwarm, and
                // build its internal objects and activities. 

                observerSwarm =
                   (ObserverSwarm)Globals.env.lispAppArchiver.getWithZone$key(
                                 Globals.env.globalZone, "observerSwarm");
                
		// to save control panel position
		Globals.env.setWindowGeometryRecordName
	    		(observerSwarm, "observerSwarm");
		
		// build objets into the obsever
		observerSwarm.buildObjects();
                
		// build actions into the obsever
		observerSwarm.buildActions();
                
		// activate
		observerSwarm.activateIn(null);

                // Now start the displaySwarm and the control panel it
                // provides.
                observerSwarm.go();

                // The user has pressed Quit.  Drop everything and return.
                observerSwarm.drop();
                }
        }
