// StopLossRuleMaster.java

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;

/**
 *This is the StopLossRuleMaster, used by StopLossAgent.
 *
 *@author Bruno Mencarelli
 *
 */

public class StopLossRuleMaster extends BasicSumRuleMaster
        {

        /** Constructor for a new StopLoss Rule Master.*/
        public StopLossRuleMaster(Zone aZone)
                {
                super(aZone);
                }

        /**This method allows the agent to apply the stoploss strategy in the first phase of the day.*/
        public double getPriceBeforeOpening(double lp, double p, double stopLossMeanPrice, double maxLossRate, double shareQuantity, int checkingIfShortOrLong)
                {
                if (agentProbToActBeforeOpening < Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0, 1.0))
                        return 0.0;
                else 
                        return this.getPrice(lp, p, stopLossMeanPrice, maxLossRate, shareQuantity, checkingIfShortOrLong);
                }

        /**This method allows the agent to apply the stoploss strategy during the simulated day.*/
        public double getPrice(double lp, double p, double stopLossMeanPrice, double maxLossRate, double shareQuantity, int checkingIfShortOrLong)

                {
                double price,  choice, stopLossChoice;

                price = lp * Globals.env.uniformDblRand.getDoubleWithMin$withMax(minCorrectingCoeff + asymmetricRange, maxCorrectingCoeff + asymmetricRange); 
                choice=1;
                if (Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0, 1.0) > p)
                        choice=-1;
                if (lp<floorP)
                        {
                        if (agentProbToActBelowFloorP > Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0, 1.0))
                                {
                                price=lp;
                                choice=1;
                                }
                        }
                if (checkingIfShortOrLong==0)
                        {
                        stopLossChoice=0;
                        if(lp>=stopLossMeanPrice*(1+maxLossRate)) stopLossChoice=1;
                        if(lp<=stopLossMeanPrice*(1-maxLossRate)) stopLossChoice=-1;
                        if(stopLossChoice!=0)
                               {
                                price=lp;
                                choice=stopLossChoice;
                               }
                        }
                if (checkingIfShortOrLong==1)
                        {
                        stopLossChoice=0;
                        if(lp>=stopLossMeanPrice*(1+maxLossRate) && shareQuantity<0) stopLossChoice=1;  
                        if(lp<=stopLossMeanPrice*(1-maxLossRate) && shareQuantity>0) stopLossChoice=-1;
                        if(stopLossChoice!=0)
                              {
                              price=lp;
                              choice=stopLossChoice;
                              }
                        }  
                return choice*price;
                }
        }

